#include "affichage.h"
#include<cstdlib>
#include<vector>
#include<iostream>
#include <queue>
#include <cmath>

using namespace std;



/* Structure Arbre binaire */
#ifndef STRUCT_ARBREB
#define STRUCT_ARBREB
struct ArbreB{
    ArbreB(string et) {etiquette=et; fg=NULL; fd=NULL;}
    ArbreB(string et, ArbreB* filsGauche, ArbreB* filsDroit) {etiquette=et; fg=filsGauche; fd=filsDroit;}
    string etiquette;
    ArbreB* fg; /* pointeur vers le fils gauche; NULL si vide */
    ArbreB* fd; /* pointeur vers le fils droit; NULL si vide */
};
#endif



/* ====  fonctions auxiliaires fournies ==== */

/* Fonction auxiliaire pour afficher les vector de string */
void affiche_vect(vector<string> &tab)
{
    int n=tab.size();
    int i;
    for (i=0; i<n; i++)
    {
        cout << i << " : " << tab[i] << " - " ;
    }
    cout << endl;
}

void libere(ArbreB* A)
{
    if (A!= NULL)
    {
        libere(A->fg);
        libere(A->fd);
        free(A);
    }
}

/* ==== PARTIE I: Mise en route ====== */
// A faire directement dans le main

/* ==== PARTIE II: Générer des arbres === */

/* Génere un arbre correspond à la formule (3x+5)-x(2x+1) */
ArbreB* arbre_formule()
{
    ArbreB* f5=new ArbreB("5");
    
    ArbreB* fx1=new ArbreB("x");
    
    ArbreB* f3=new ArbreB("3");
    
    ArbreB* fx2=new ArbreB("x");
    
    ArbreB* f2=new ArbreB("2");
    
    ArbreB* fx3=new ArbreB("x");
    
    ArbreB* f1=new ArbreB("1");
    
    ArbreB* n3x=new ArbreB("*", f3, fx1);
    
    ArbreB* n3xp5=new ArbreB("+", n3x, f5);
    
    ArbreB* n2x=new ArbreB("*", f2, fx3);
    
    ArbreB* n2xp1=new ArbreB("+", n2x, f1);
    
    ArbreB* nx2xp1=new ArbreB("*", fx2, n2xp1);
    
    ArbreB* formule=new ArbreB("- ", n3xp5, nx2xp1);
    
    return formule;
}


/* ====== PARTIE III: Jouer avec les arbres ===== */



/* ===== PARTIE IV: parcours d'arbres prefixe, infixe, postfixe ===== */



/* ===== PARTIE V: parcours en largeur ===== */



/* ==== PARTIE VI: Arbres binaires de recherche (ABR) ==== */


/* ==== PARTIE VII: Convertir un arbre ternaire en arbre binaire ==== */



/* ===== FONCTION MAIN: tests des fonctions ===============*/
int main(int argc, char* argv[])
{
    /* Crée puis affiche un (pointeur sur un) arbre feuille_a composé seulement d'une feuille étiquettée a */
    ArbreB* feuille_a=new ArbreB("a");
    affiche_arbre(feuille_a, "feuille_a");
    // Note: signature de affiche_arbre: void affiche_arbre(ArbreB* A, string nom_dans_la_phrase_d_intro)
    
    /* Crée un (pointeur sur un) arbre feuille_b composé seulement d'une feuille étiquettée b */
    ArbreB* feuille_b=new ArbreB("b");
    
    /* Crée un (pointeur sur un) arbre A1 composé d'une racine étiquettée c, et admettant comme fils gauche l'arbre feuille_a, et comme fils droit l'arbre feuille_b. Affiche ensuite A1. */
    ArbreB* A1=new ArbreB("c", feuille_a, feuille_b);
    affiche_arbre(A1, "A1");
    
    /* Change l'étiquette de la racine de A1, puis affiche A1 */
    A1->etiquette="cc";
    affiche_arbre(A1, "A1");
    
    /* Crée un arbre B1 composé d'une racine étiquetée d, ayant pour fils gauche une feuille étiquetée e et pour fils droit une feuille etiquettée f. Affiche ensuite B1. */
    ArbreB* B1=new ArbreB("d",new ArbreB("e"),new ArbreB("f"));
    affiche_arbre(B1, "B1");
    
    /* Crée un arbre A2 en utilisant plusieurs constructeurs d'arbres imbriqués. Affiche ensuite A2. */
    ArbreB* A2=new ArbreB("r",new ArbreB("s"),new ArbreB("t", new ArbreB("u"),new ArbreB("v") ));
    affiche_arbre(A2, "A2");
    
   
    /* Modifie A2 pour que le noeud etiquetté par s soit remplacé par un arbre contenant une racine étiquettée par "s1" et deux fils étiquettés "s2" et "s3". Ensuite, ré-affiche A2. */
    A2->fg= new ArbreB("s1", new ArbreB("s2"), new ArbreB("s3"));
    affiche_arbre(A2, "A2");
    
    /* Exemple où l'on enchaine plusieurs fois l'opérateur "->": afficher l'étiquette du fils droit du fils gauche de A2, ou autrement dit, en partant de la racine, en descend vers le fils gauche, puis vers le fils droit de ce noeud, puis on demande l'étiquette. */
    cout << "Test1: " << (A2->fg->fd->etiquette) << endl;
    
    /* A completer */
    // Q 1.1: Modifier A2 pour que le noeud étiquetté s3 recoive comme fils gauche l'arbre A1, et que le noeud étiquetté par u recoive comme fils gauche l'arbre B1;
    // .....
    // .....
    // .....
    
    // Q1.2: Affiche le sous-arbre enraciné au noeud d'étiquette u: en partant de la racine de A2, il faut descendre en suivant le chemin .......... .
    // ............
    
    // Q1.3: Supprimer dans A2 le sous-arbre d'étiquette u
    // .............
    
    
    // Pour Exercice 2:
    //ArbreB* F=arbre_formule();
    //affiche_arbre(F, "F");
    
    // Pour Exercice 4
    //cout << "Parcours infixe de F: " << parcours_infixe(F)<< endl;
    //cout << "Parcours prefixe de F: " << parcours_prefixe(F)<< endl;
    //cout << "Parcours postfixe de F: " << parcours_postfixe(F)<< endl;

    // Pour Exercice 5
    //cout << "Parcours largeur de A2: " << parcours_largeur(A2) << endl;
    
    
    /* On libère l'espace alloué */
    //libere(F);
    
    return EXIT_SUCCESS;
}
